/*
 * This program converts the input signal to an m-frame 
 * transport smoothed signal for an arbitrarily selected
 * value of m. It produces a file with frame sizes, rates,
 * and duration for the m-frame transport signal.
 *
 * Juan Miguel del Rosario, (c) 1995.
 * All rights reserved.
 */

#include <stdio.h>
#include <string.h>

#ifdef NOTSELFRUN
scanvbr(filename, m) 
  char *filename;
  int m;
#else 
main(argc, argv)
  int argc;
  char *argv[];
#endif
{
   FILE *fd;
   FILE *fd1;
   FILE *fdo;
   int i,j,k;
   char fname[15];
   double mframe;
   double ave = 0;
   int start, end;
   double rate, time;
   int fsize, indx;

#ifdef NOTSELFRUN
   strcpy(fname, filename);
   start = m;
#else
   if (argc < 3) {
      printf("Usage: scanvbr [filename] [m]\n");
      exit(1);
   } else {
      strcpy(fname, argv[1]);    
      start = (int) atoi(argv[2]);
   }
#endif

   fd = fopen(fname, "r");
   if (fd == 0) {
      printf("Some error on open\n");
   }
   fd1 = fopen(fname, "r");
   if (fd1 == 0) {
      printf("Some error on open\n");
   }
   fdo = fopen("mfvbr.dat", "wt");
   if (fdo == 0) {
      printf("some error opening\n");
   }
   i = start;

#ifndef NOTSELFRUN
   fprintf(fdo, "+----------------------------\n");
   fprintf(fdo, "| m = %d   ave = %9.2f\n", i, ave);
   fprintf(fdo, "| indx  frame  rate  duration\n");
   fprintf(fdo, "+----------------------------\n");
#endif 

   fseek(fd,0,0);
   while (!feof(fd)) {
      mframe = 0;
      k = 0;
      j = 1;
      while (j <= i) {
        fscanf(fd,"%d %d", &indx, &fsize);
        if (feof(fd)) {
           break; 
        }
        mframe = mframe + (fsize*1.0);
        k++;
        j++; 
      }
      rate = (mframe/k)*30;
      for (j=1; j <= k; j++) {
         fscanf(fd1,"%d %d", &indx, &fsize);
         time = fsize/rate;
         fprintf(fdo,"%d %d %e %e\n", indx, fsize, rate, time);
/* fprintf(fdo,"%4d  %6d   %9.2f   %2.4f\n", indx, fsize, rate, time); */
      }
   }
   fclose(fd);
   fclose(fd1);
   fclose(fdo);
}


